// support code for Eeek!  XML!  Over at MacEdition
// http://macedition.com/bolts/bolts_20030610.php

// this code is in the public domain.  have fun.

#import <Foundation/Foundation.h>
#import "display.h"


// given a node type, return the name.

static const char *nodeTypeDescription (CFXMLNodeTypeCode type)
{
    const char *result = "unknown node type";

    switch (type) {
    case kCFXMLNodeTypeDocument:
	result = "document";
	break;
    case kCFXMLNodeTypeElement:
	result = "element";
	break;
    case kCFXMLNodeTypeAttribute:
	result = "attribute";
	break;
    case kCFXMLNodeTypeProcessingInstruction:
	result = "processing instruction";
	break;
    case kCFXMLNodeTypeComment:
	result = "comment";
	break;
    case kCFXMLNodeTypeText:
	result = "text";
	break;
    case kCFXMLNodeTypeCDATASection:
	result = "CDATA section";
	break;
    case kCFXMLNodeTypeDocumentFragment:
	result = "document fragment";
	break;
    case kCFXMLNodeTypeEntity:
	result = "entity";
	break;
    case kCFXMLNodeTypeEntityReference:
	result = "entity reference";
	break;
    case kCFXMLNodeTypeDocumentType:
	result = "document type";
	break;
    case kCFXMLNodeTypeWhitespace:
	result = "whitespace";
	break;
    case kCFXMLNodeTypeNotation:
	result = "notation";
	break;
    case kCFXMLNodeTypeElementTypeDeclaration:
	result = "element type declaration";
	break;
    case kCFXMLNodeTypeAttributeListDeclaration:
	result = "attribute list declaration";
	break;
    }

    return (result);

} // nodeTypeDescription



// recursively walk the CFTree and display the contents

void dumpTree (CFTreeRef tree, int level)
{
    int i;

    // cheezy indentation showing the structure
    for (i = 0; i < level; i++) {
	printf ("    ");
    }

    CFXMLNodeRef node;
    node = CFXMLTreeGetNode (tree);

    CFStringRef string;
    string = CFXMLNodeGetString (node);

    CFXMLNodeTypeCode type;
    type = CFXMLNodeGetTypeCode (node);

    char buffer[4096];

    // display the contents for this node
    if (CFStringGetCString (string, buffer, 4096, kCFStringEncodingUTF8)) {
	printf ("%s (%s)\n", buffer, nodeTypeDescription(type));
    }

    // display the children
    for (i = 0; i < CFTreeGetChildCount(tree); i++) {
	CFTreeRef child;
	child = CFTreeGetChildAtIndex (tree, i);
	dumpTree (child, level + 1);
    }

} // dumpTree

